#ifndef __NPC_SCHEDULEMAN_H__
#define __NPC_SCHEDULEMAN_H__

#define CHARNAME_MAX	32

//  scheduleman 
#ifdef _FAMILY_MANORNUM_CHANGE
#define MAX_SCHEDULEMAN	20
#else
#define MAX_SCHEDULEMAN	12
#endif

// ÿһ scheduleman عܵ schedule 
#define MAX_SCHEDULE	24

// schedule бһҳг
#define MAXSCHEDULEINONEWINDOW	10

// family бһҳг
#define MAXFAMILYINONEWINDOW	10

// ÿһ scheduleman ʹõ schedule λ
// Ӧ fmpks  ID*MAX_SCHEDULE  (ID=0~MAX_SCHEDULEMAN-1)
// ID д data/npc ָ "id:" ֵ

// dueltime = (?10000:0) + (Сʱ*100)

typedef struct tagFamilyPKSchedule {
	int	dueltime;	// ʱ
	int	host_index;	// Ӽ
	char host_name[CHARNAME_MAX];	// Ӽ
	int	guest_index;	// ͶӼ
	char guest_name[CHARNAME_MAX];	// ͶӼ
	int	prepare_time;	// ׼ʱ (1~40 )
	int	max_player;	//  (1~)
	int	flag;		// ״̬
	int	win;		// ʤ趨
	int	challenge_timeout;	// սʱ
	int	setting_timeout;	// 趨״̬ timeout
	char gmsv_name[256];
} FamilyPKSchedule;

// ¼ FamilyPKSchedule (fmpks)  flag ֵ
#define FMPKS_FLAG_NONE		-1	// ûκų
#define FMPKS_FLAG_CHALLENGE	0	// ȴͶͬ
#define FMPKS_FLAG_SETTING	1	// 趨ų (ȡʱ NONE)
#define FMPKS_FLAG_CONFIRMING	2	// Ͷͬ
#define FMPKS_FLAG_SCHEDULED	3	// Ѿźų̣δ
#define FMPKS_FLAG_DUEL		4	// 
#define FMPKS_FLAG_HOSTWIN	5	// ʤ
#define FMPKS_FLAG_GUESTWIN	6	// Ͷʤ
#define FMPKS_FLAG_MANOR_BATTLEBEGIN	7	// ׯ԰ս ս
#define FMPKS_FLAG_MANOR_PREPARE	8	// ׯ԰ս ׼
#define FMPKS_FLAG_MANOR_PEACE	9	// ׯ԰ս ս
#define FMPKS_FLAG_MANOR_OTHERPLANET	10	// ׯ԰ս ڱս
#define FMPKS_FLAG_MANOR_BATTLEEND	11	// ׯ԰ս ս
#define FMPKS_FLAG_MANOR_PEACE_SAVE	12	// ׯ԰ս浵
#define FMPKS_FLAG_MANOR_READYTOFIGHT	13	// (GM: manorpk) ȫϵɿԼս״̬
#define FMPKS_FLAG_MANOR_CLEANFLAG	14	// (GM: manorpk) ״̬
#ifdef _NEW_MANOR_LAW
#define FMPKS_FLAG_WAIT		15	// ս,Ѽ¼,ȴսų
#endif

//  client  flag
#define FLAG_NONE	-1
#define FLAG_MODIFY	0
#define FLAG_ACCEPT	1
#define FLAG_SETTING	2
#define FLAG_CONFIRM	3
#define FLAG_SCHEDULED	4

extern FamilyPKSchedule fmpks[MAX_SCHEDULE*MAX_SCHEDULEMAN];

BOOL NPC_SchedulemanInit(int meindex);
void NPC_SchedulemanTalked(int meindex, int talkerindex, char *msg, int color);
void NPC_SchedulemanWindowTalked(int meindex, int talkerindex,
				 int seqno, int select, char *data);
void NPC_SchedulemanLoop(int meindex);

#endif 

/*__NPC_SCHEDULEMAN_H__*/
