#include "version.h"
#include <unistd.h>
#include <stdio.h>
#include <strings.h>
#include <unistd.h>


#include "configfile.h"
#include "util.h"
#include "net.h"
#include "msignal.h"
#include "buf.h"
#include "object.h"
#include "char.h"
#include "char_data.h"
#include "item.h"
#include "readmap.h"
#include "function.h"
#include "saacproto_cli.h"
#include "lssproto_serv.h"
#include "readnpc.h"
#include "log.h"
#include "handletime.h"
#include "title.h"
#include "encount.h"
#include "enemy.h"
#include "battle.h"
#include "magic_base.h"
#include "pet_skill.h"
#include "item_gen.h"
#include "petmail.h"
#include "npc_quiz.h"
#ifdef _ALLBLUES_LUA
#include "mylua/mylua.h"
#endif
#ifdef _PROFESSION_SKILL			// WON ADD ְҵ
#include "profession_skill.h"
#endif

#ifdef _ITEM_QUITPARTY
#include "init.h"
//int itemquitparty_num = 0;
//static DisappearItem *Disappear_Item;
#endif

#define MESSAGEFILE "hoge.txt"

#define OPTIONSTRING "d:f:h"
#define usage() print( "Usage: %s ["OPTIONSTRING"]\n", getProgname() );
extern int yzflg;
void printUsage( void )
{
    usage();
  /*print( "Usage: %s ["OPTIONSTRING"]\n", progname );*/
    print( "          [-d debuglevel]        default value is 0\n" );
    print( "          [-f configfilename]    default value is setup.cf\n"
        );
}

/*
 *
 * ¦
 * ߯Ի
 *      TRUE(1)     ئѨ̼¦ѷ
 *      FALSE(0)    ئѨ̼¦ѷ
 */
BOOL parseCommandLine( int argc , char** argv )
{
    int c;                          /* getopt ƥ */
    extern char* optarg;            /* getopt ƥ */


    while( ( c = getopt( argc, argv ,OPTIONSTRING )) != -1 ){
        switch( c ){
        case 'd':
        {
            int     debuglevel;
            if( !strtolchecknum( optarg, (int*)&debuglevel, 10,
                                 INT)){
                print( "Specify digit number\n" );
                return FALSE;
            }
            setDebuglevel( debuglevel );
            break;
        }
        case 'f':
            setConfigfilename( optarg );
            break;
        case 'h':
            printUsage();
            return FALSE;
            break;

        default:
            printUsage();
            return FALSE;
            break;

        }
    }
    return TRUE;
}


/*
 * ¦
 *
 * ἰئ
 */
BOOL parseEnvironment( char** env )
{
    if( getDebuglevel() >= 3 ){
        int index=0;
        while( env[index] != NULL )print( "%s " , env[index++] );
        print( "\n" );
    }
    return TRUE;
}




#define LSGENWORKINGBUFFER  65536*4



#define GOTORETURNFALSEIFFALSE(x) if(!(x))goto RETURNFALSE
/*
 * 
 * ¦
 *      argc    argv
 *      argv    Ѩ̼¦
 * ߯Ի
 */
BOOL init(int argc , char** argv , char** env )
{
#ifdef _ITEM_QUITPARTY
    FILE *f;
	int i;
	char line[256];
#endif
    srand( getpid());
    print( "This Program is compiled at %s %s by gcc %s\n",
           __DATE__ , __TIME__ , __VERSION__ );

    defaultConfig( argv[0] );
    signalset();

    GOTORETURNFALSEIFFALSE(parseCommandLine( argc , argv ));
    GOTORETURNFALSEIFFALSE(parseEnvironment( env ));

    {
        Char    aho;
        debug( sizeof( aho ), d);
        debug( sizeof( aho.data ), d);
        debug( sizeof( aho.string ), d);
        debug( sizeof( aho.flg ),d);
        debug( sizeof( aho.indexOfExistItems ), d);
        debug( sizeof( aho.haveSkill ), d);
        debug( sizeof( aho.indexOfHaveTitle ), d);
        debug( sizeof( aho.addressBook ),d);
        debug( sizeof( aho.workint ),d);
        debug( sizeof( aho.workchar ),d);
    }

    print( "ļ: %s\n" , getConfigfilename() );
		
    GOTORETURNFALSEIFFALSE(readconfigfile( getConfigfilename() ) );
    
    nice(getrunlevel());
    //ttom start
    {  int iWork = setEncodeKey();
       if( iWork == 0 ){
       // ޼ƽëɬ
       printf( "----------------------------------------\n" );
       printf( "-------------[] ޷ %s\n", getConfigfilename() );
       printf( "----------------------------------------\n" );
       exit( 1 );
       }else{
            // ޼ƽëɬ
               printf( " = %d\n", iWork );
       }
    }
    // AcWBuffëɬ
    {   int iWork = setAcWBSize();
        if( iWork == 0 ){
           printf( "----------------------------------------\n" );
           printf( "-------------[AC] ޷ %s\n", getConfigfilename() );
           printf( "----------------------------------------\n" );
           exit( 1 );
           }else{
                   printf( "AC = %d\n", iWork );
           }
    }
    //ttom end

    if( getDebuglevel() >= 1 ){
//		print("ServerType: %d\n", getServerType() );
				print("Եȼ: %d\n", getDebuglevel() );
				print("еȼ: %d\n", getrunlevel() );
				print("ջ: %d\n", getrecvbuffer()*1024);
				print("ͻ: %d\n", getsendbuffer()*1024);
				print("ջ: %d\n", getrecvlowatbuffer());
        print("ڴ浥ԪС: %d\n", getMemoryunit() );
        print("ڴ浥Ԫ: %d\n", getMemoryunitnum() );

        print("˺ŷַ: %s\n", getAccountservername() );
        print("˺ŷ˿: %d\n", getAccountserverport() );
        print("½: %s\n",
              getGameservername());
        print("½: %s\n", getAccountserverpasswd());

        print("ȴӶ˿: %d\n", getPortnumber() );

        print("к: %d\n", getServernumber() );

        print("ظַʹ: %d\n", getReuseaddr() );


        print(": %d\n", getFdnum() );
        print("߳: %d\n", getPetcharnum() );
        print("Ŀ: %d\n", getOtherscharnum() );
        print("Ŀ: %d\n", getObjnum() );
        print("ƷĿ: %d\n", getItemnum() );
        print("սĿ: %d\n", getBattlenum() );
        print("ļĿ¼: %s\n", getTopdir());
        print("ͼļĿ¼: %s\n", getMapdir());
        print("ͼʶļ: %s\n", getMaptilefile());
        print("Ʒļ: %s\n", getItemfile());
        print("սļ: %s\n", getInvfile());
        print("ʾλļ: %s\n", getAppearfile());
        print("ļ: %s\n", getEffectfile());
        print("ͷļ: %s\n", getTitleNamefile());
        print("ͷļ: %s\n", getTitleConfigfile());
        print("ļ: %s\n", getEncountfile());
        print("Ⱥļ: %s\n", getGroupfile());
        print("ļ: %s\n", getEnemyBasefile());
        print("ļ: %s\n", getEnemyfile());
        print("ħļ: %s\n", getMagicfile());

#ifdef _ATTACK_MAGIC
        print("ħļ: %s\n", getAttMagicfileName() );
#endif

        print("＼ļ: %s\n", getPetskillfile());

#ifdef _PROFESSION_SKILL			// WON ADD ְҵ
        print("ְҵļ: %s\n", getProfession());
#endif

        print("Ʒɷļ: %s\n", getItematomfile());
        print("ļ: %s\n", getQuizfile());
#ifdef _GMRELOAD
				print("G M ļ: %s\n", getGMSetfile());
#endif
        print("־¼ļ: %s\n",  getLsgenlogfilename() );
        print("ԭĿ¼: %s\n", getStoredir());
        print("NPC Ŀ¼: %s\n", getNpcdir());
        print("־ļ: %s\n",  getLogdir());
        print("־ļ: %s\n", getLogconffile() );
        print("GMָ: %s\n", getChatMagicPasswd() );
        print("ʹGMȨ: %d\n", getChatMagicCDKeyCheck() );

        print("NPC ģĿ: %d\n", getNpctemplatenum() );
        print("NPC Ŀ: %d\n", getNpccreatenum() );

        print("·ʱ: %d\n", getWalksendinterval());
        print("м: %d\n", getCAsendinterval_ms());
        print("Ŀ: %d\n", getCDsendinterval_ms());
        print("ִһʱ: %d\n", getOnelooptime_ms());
        print("ʱ: %d\n", getPetdeletetime());
        print("ʱ: %d\n", getItemdeletetime());
#ifdef _DEL_DROP_GOLD
				print("ʯʱ: %d\n", getGolddeletetime());
#endif
        print("ݱ: %d\n", getCharSavesendinterval());

        print("ƬĿ: %d\n", getAddressbookoffmsgnum());
        print("ȡƵЭ: %d\n" ,getProtocolreadfrequency());

        print("Ӵ: %d\n", getAllowerrornum());
#ifdef _GET_BATTLE_EXP
				print("ս鱶: %d\n", getBattleexp() );
#endif
#ifdef _NEW_PLAYER_CF
				print("ת: %dת\n", getNewplayertrans());
				print("ȼ: %d\n", getNewplayerlv());
				print("Ǯ: %d S\n", getNewplayergivegold());
				print("ȼ: %d\n", getNewplayerpetlv());
#ifdef _VIP_SERVER
				print("ӵе: %d\n", getNewplayergivevip());
#endif
				print("ȼ: %d\n", getRidePetLevel());
#ifdef _NEW_PLAYER_RIDE
				print(": %s\n", getPlayerRide());
#endif
				print("ӵг: NO1:%d NO2:%d NO3:%d NO4:%d NO5:%d\n",getNewplayergivepet(0),
																																	getNewplayergivepet(1),
																																	getNewplayergivepet(2),
																																	getNewplayergivepet(3),
																																	getNewplayergivepet(4));
				print("ӵƷ: ITEM1:%d ITEM2:%d ITEM3:%d ITEM4:%d ITEM5:%d\n"
							"ITEM1:%d ITEM2:%d ITEM3:%d ITEM4:%d ITEM5:%d\n"
							"ITEM1:%d ITEM2:%d ITEM3:%d ITEM4:%d ITEM5:%d\n"
																																	,getNewplayergiveitem(0)
																																	,getNewplayergiveitem(1)
																																	,getNewplayergiveitem(2)
																																	,getNewplayergiveitem(3)
																																	,getNewplayergiveitem(4)
																																	,getNewplayergiveitem(5)
																																	,getNewplayergiveitem(6)
																																	,getNewplayergiveitem(7)
																																	,getNewplayergiveitem(8)
																																	,getNewplayergiveitem(9)
																																	,getNewplayergiveitem(10)
																																	,getNewplayergiveitem(11)
																																	,getNewplayergiveitem(12)
																																	,getNewplayergiveitem(13)
																																	,getNewplayergiveitem(14));
#endif
#ifdef _UNREG_NEMA
		print("ֹ: 1:%s 2:%s 3:%s 4:%s 5:%s\n",getUnregname(0),
																																	getUnregname(1),
																																	getUnregname(2),
																																	getUnregname(3),
																																	getUnregname(4));
#endif
#ifdef _UNLAW_WARP_FLOOR
		print("ֹ͵ͼ: ͼ1:%d ͼ2:%d ͼ3:%d ͼ4:%d ͼ5:%d\n"
	          "              ͼ1:%d ͼ2:%d ͼ3:%d ͼ4:%d ͼ5:%d\n",getUnlawwarpfloor(0),
																																					getUnlawwarpfloor(1),
																																					getUnlawwarpfloor(2),
																																					getUnlawwarpfloor(3),
																																					getUnlawwarpfloor(4),
																																					getUnlawwarpfloor(5),
																																					getUnlawwarpfloor(6),
																																					getUnlawwarpfloor(7),
																																					getUnlawwarpfloor(8),
																																					getUnlawwarpfloor(9));
#endif
#ifdef _WATCH_FLOOR
		print("Ƿȫͼս: %s\n",getWatchFloorCF());
		if(strcmp(getWatchFloorCF(),""))
			print("սͼ: ͼ1:%d ͼ2:%d ͼ3:%d ͼ4:%d ͼ5:%d\n",getWatchFloor(1),
																																		getWatchFloor(2),
																																		getWatchFloor(3),
																																		getWatchFloor(4),
																																		getWatchFloor(5));
#endif

#ifdef _BATTLE_FLOOR
		print("Ƿǿս: %s\n",getBattleFloorCF());
		if(strcmp(getBattleFloorCF(),""))
			print("ǿսͼ: ͼ1:%d ͼ2:%d ͼ3:%d ͼ4:%d ͼ5:%d\n",getBattleFloor(1),
																																		getBattleFloor(2),
																																		getBattleFloor(3),
																																		getBattleFloor(4),
																																		getBattleFloor(5));
#endif

#ifdef _TRANS_LEVEL_CF
		print("ȼת: %d\n",getChartrans());
		print("ȼת: %d\n",getPettrans());
#endif

#ifdef _POINT
		print("ֹ: %s\n",getPoint());
		if(strcmp(getPoint(),""))
			print("ÿת: 0ת:%d 1ת:%d 2ת:%d 3ת:%d 4ת:%d 5ת:%d 6ת:%d\n",getTransPoint(0),
																																								getTransPoint(1),
																																								getTransPoint(2),
																																								getTransPoint(3),
																																								getTransPoint(4),
																																								getTransPoint(5),
																																								getTransPoint(6));
#endif
//#ifdef _PET_UP
//		print("ܷ: %s\n",getPetup());
//#endif
#ifdef _LOOP_ANNOUNCE
		print("ѭ·: %s\n",getLoopAnnouncePath());
		print("ѭʱ: %d\n",getLoopAnnounceTime());
#endif
#ifdef _SKILLUPPOINT_CF
		print("ÿ: %d\n",getSkup());
#endif

#ifdef _RIDELEVEL
		print("ȼ: %d\n",getRideLevel());
#endif
#ifdef _REVLEVEL
		print("ԭ޵ȼ: %s\n",getRevLevel());	
#endif
#ifdef _TRANS_LEVEL_CF
		print("һȼ: %d\n",getYBLevel());	
		print("ߵȼ: %d\n",getMaxLevel());	
#endif
#ifdef _FIX_CHARLOOPS
	print("ħʱ䱶: %d\n",getCharloops());	
#endif
#ifdef _PLAYER_ANNOUNCE
	if(getPAnnounce()==-1)
		print("ĵ: رʹ\n");
	else
		print("ĵ: %d\n",getPAnnounce());	
#endif
#ifdef _PLAYER_MOVE
	if(getPMove()==-1)
		print("˳ĵ: رʹ\n");	
	else
		print("˳ĵ: %d\n",getPMove());	
#endif
#ifdef _BATTLE_GOLD
		print("սýǮ: %d%\n",getBattleGold());	
#endif
#ifdef _ANGEL_TIME
		print("ٻʱ: (%d/)\n",getAngelPlayerTime());	
		print("ٻ: %d\n",getAngelPlayerMun());	
#endif
#ifdef _RIDEMODE_20
		print("2.0 ģʽ: %d\n",getRideMode());	
#endif
#ifdef _FM_POINT_PK
		print("ׯ԰ģʽ: %s\n",getFmPointPK());	
#endif
#ifdef _CAX_ESC_REPORT
		print("ͨԱǩ: ITEM1:%d ITEM2:%d ITEM3:%d ITEM4:%d ITEM5:%d\n"
				,getReportItem(0)
				,getReportItem(1)
				,getReportItem(2)
				,getReportItem(3)
				,getReportItem(4));
		print("VIP Աǩ: ITEM1:%d ITEM2:%d ITEM3:%d ITEM4:%d ITEM5:%d\n"
				,getVipReportItem(0)
				,getVipReportItem(1)
				,getVipReportItem(2)
				,getVipReportItem(3)
				,getVipReportItem(4));
#endif
    }

	{	//andy_add 2003/05/05 check GameServer Name
		char *GameServerName;
		GameServerName = getGameserverID();
		if( GameServerName == NULL || strlen( GameServerName) <= 0 )
			return FALSE;
		print("\nϷID: %s\n",  GameServerName );
	}
    print("ʼʼ\n" );
 #ifdef _TRANS_7_COLOR
    if(getping())
		{
			print("ʾ\n");
			system("echo 1 > /proc/sys/net/ipv4/icmp_echo_ignore_all");
		}else
		{
			print("ʾ\n");
			system("echo 0 > /proc/sys/net/ipv4/icmp_echo_ignore_all");
		}  
#endif   
//#define DEBUG1( arg... ) if( getDebuglevel()>1 ){##arg}
    print( "ڴռ..." );
    GOTORETURNFALSEIFFALSE(configmem( getMemoryunit(),
                                      getMemoryunitnum() ) );
    GOTORETURNFALSEIFFALSE(memInit());
		print( "\n" );
				
		print( "ʼջӿռ..." );
    if( !initConnect(getFdnum()) )
        goto MEMEND;
    print( "\n" );
    while( 1 ){
        print( "԰󶨱ض˿ %d... " , getPortnumber());
        bindedfd = bindlocalhost( getPortnumber() );
        if( bindedfd == -1 )
            sleep( 10 );
        else
            break;
    }
	print( "\n" );

	print( "..." );
    if( !initObjectArray( getObjnum()) )
        goto CLOSEBIND;
	print( "\n" );
	
	print( "..." );
#ifdef _OFFLINE_SYSTEM
    if(!CHAR_initCharArray( getPlayercharnum(), getPetcharnum(),getOtherscharnum()) )
#else
    if(!CHAR_initCharArray( getFdnum(), getPetcharnum(),getOtherscharnum()) )
#endif
        goto CLOSEBIND;
	print( "\n" );
	print( "Ʒ...");
    if(!ITEM_readItemConfFile( getItemfile()) )
        goto CLOSEBIND;
    if(!ITEM_initExistItemsArray( getItemnum() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ս..." );
    if(!BATTLE_initBattleArray( getBattlenum() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ģ..." );
    if( !initFunctionTable() )
        goto CLOSEBIND;
	print( "\n" );
	
//	print("ʼ˺Űȫ...");
//		if( !cdkeyinit() )
//			goto CLOSEBIND;
//	print( "\n" );

	print( "ʼʼ..." );
    if( !PETMAIL_initOffmsgBuffer( getAddressbookoffmsgnum() ))
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡսļ..." );
    if( !CHAR_initInvinciblePlace( getInvfile() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡʾλļ..." );
    if( !CHAR_initAppearPosition( getAppearfile() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡͷļ..." );
    if( !TITLE_initTitleName( getTitleNamefile() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡͷļ..." );
    if( !TITLE_initTitleConfig( getTitleConfigfile() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡļ..." );
    if( !ENCOUNT_initEncount( getEncountfile() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡļ..." );
    if( !ENEMYTEMP_initEnemy( getEnemyBasefile() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡļ..." );
    if( !ENEMY_initEnemy( getEnemyfile() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡȺļ..." );
    if( !GROUP_initGroup( getGroupfile() ) )
        goto CLOSEBIND;
	print( "\n" );
	print( "ȡħļ..." );
    if( !MAGIC_initMagic( getMagicfile() ) )
        goto CLOSEBIND;
	print( "\n" );

		#ifdef _ATTACK_MAGIC

	print( "ȡħļ..." );

    if( !ATTMAGIC_initMagic( getAttMagicfileName() ) )
//		if( !ATTMAGIC_initMagic( getMagicfile() ) )
        goto CLOSEBIND;

	print( "ħļ -->%s..." , getAttMagicfileName());
	print( "\n" );

    #endif
 
	print( "ȡ＼ļ..." );
    if( !PETSKILL_initPetskill( getPetskillfile() ) )
        goto CLOSEBIND;
	print( "\n" );

#ifdef _PROFESSION_SKILL			// WON ADD ְҵ
	print( "ȡְҵļ..." );
	if( !PROFESSION_initSkill( getProfession() ) ){
		goto CLOSEBIND;
	}
	print( "\n" );
#endif

    /* ʧ  ة    ë   */
	print( "ȡƷɷļ..." );
    if( !ITEM_initItemAtom( getItematomfile()) )
        goto CLOSEBIND;
	print("\n" );

	print( "ʼϳƷ..." );
    if( !ITEM_initItemIngCache() )
        goto CLOSEBIND;
	print("\n" );
    
	print( "ʼϳ趨..." );
    if( !ITEM_initRandTable() )
        goto CLOSEBIND;
	print("\n" );
  
	print( "ȡļ..." );
    if( !CHAR_initEffectSetting( getEffectfile() ) )
        goto CLOSEBIND;
	print( "\n" );
	print( "ȡļ..." );
    if( !QUIZ_initQuiz( getQuizfile() ) )
        goto CLOSEBIND;
	print( "\n" );
#ifdef _GMRELOAD
	print( "ȡGMļ..." );
	if ( !LoadGMSet( getGMSetfile() ) )
		goto CLOSEBIND;
	print( "\n" );
#endif
#ifdef _UNTEXT_TALK
	print("ȡֹؼļ...");
	if(!LoadUnText())
		goto CLOSEBIND;
	print( "\n" );
#endif
#ifdef _USER_EXP_CF
	print( "ȡļ..." );
	if ( !LoadEXP( getEXPfile() ) )
		goto CLOSEBIND;
	print("ߵȼ: %d...",getMaxLevel());
	print("һȼ: %d...",getYBLevel());
	print( "\n" );
#endif

#ifdef _ANGEL_SUMMON
	print("ȡٻбļ...");
	if( !LoadMissionList( ) )
		goto CLOSEBIND;
	print("\n");
#endif

#ifdef _JOBDAILY
	print("ȡ־ļ...");
	if(!LoadJobdailyfile())
		print("...ʧ\n");
	else
		print("\n");
#endif

#ifdef _LOOP_ANNOUNCE
	print("ȡѭļ...");
	if(!loadLoopAnnounce())
		print("...ʧ\n");
	else
	 print("\n");
#endif
#ifdef _RIDE_CF
	print( "ȡԶļ..." );
	if(!CHAR_Ride_CF_init())
		print("...ʧ\n");
	print("\n");
#endif
#ifdef _FM_LEADER_RIDE
	print( "ȡׯ԰峤רļ..." );
	if(!CHAR_FmLeaderRide_init())
		print("...ʧ\n");
	print("\n");
#endif
#ifdef _RE_GM_COMMAND
	print( "ԶGMļ..." );
	if(!re_gm_command())
		print("...ʧ\n");
	print("\n");
#endif
#ifdef _NEED_ITEM_ENEMY
	print( "ȡץҪƷļ..." );
	if(!need_item_eneny_init())
		print("...ʧ\n");
	print("\n");
#endif
	print( "ͼ..." );
    if( !MAP_initReadMap( getMaptilefile() , getMapdir() ))
        goto CLOSEBIND;
	print( "\n" );
	print( "ȡNPCļ..." );
    if( !NPC_readNPCSettingFiles( getNpcdir(), getNpctemplatenum(),
                                  getNpccreatenum() ) )
        goto CLOSEBIND;
	print( "\n" );
	print( "ʼ NPC ... " );
    if( lssproto_InitServer( lsrpcClientWriteFunc, LSGENWORKINGBUFFER ) < 0 )
        goto CLOSEBIND;
	print( "\n" );
	print( "˺ŷ... " );
    acfd = connectHost( getAccountservername(), getAccountserverport());
    if(acfd == -1)
        goto CLOSEBIND;

/*
	{
		int errorcode;
		int errorcodelen;
		int qs;

		errorcodelen = sizeof(errorcode);
		qs = getsockopt( acfd, SOL_SOCKET, SO_RCVBUF , &errorcode, &errorcodelen);
		//andy_log
		print("\n\n GETSOCKOPT SO_RCVBUF: [ %d, %d, %d] \n", qs, errorcode, errorcodelen);
	}
*/

	print( "\n" );
    initConnectOne( acfd, NULL , 0 );
    if( !CONNECT_acfdInitRB( acfd)) goto CLOSEAC;
    if( !CONNECT_acfdInitWB( acfd)) goto CLOSEAC;
    CONNECT_setCtype( acfd, AC );
	
	print( "ʼ NPC ͻ ... " );
    /*  rpc(client) */
    if( saacproto_InitClient( lsrpcClientWriteFunc,LSGENWORKINGBUFFER, acfd) < 0)
        goto CLOSEAC;
	print( "\n" );

	print( "˺ŷ͵½... " );
    /*  ̼ۢë  */
   	{
			char buff[50];
#ifdef _TEST_SERVER
			sprintf(buff,"ziyunjack8-%s-%d",getAccountserverpasswd(),987);
			saacproto_ACServerLogin_send(acfd, getGameservername(), buff);
#else
			sprintf(buff,"ziyunjack8-%s-%d",getAccountserverpasswd(),789);
			saacproto_ACServerLogin_send(acfd, getGameservername(), buff);
#endif
    }
	print( "\n" );
  // if (strcmp(getlocaltime(), TimeLimitLocal)>0)exit(0);
    if( isExistFile( getLsgenlogfilename() ) ){
        lssproto_SetServerLogFiles( getLsgenlogfilename(),
                                    getLsgenlogfilename() );
        saacproto_SetClientLogFiles( getLsgenlogfilename(),
                                     getLsgenlogfilename() );
    }


	print( "ʼ\n" );

	print( "ʼʼ־\n" );
    {
        char    logconffile[512];
        snprintf( logconffile, sizeof( logconffile), "%s/%s" ,
                  getLogdir(), getLogconffile() );
        if( !initLog( logconffile ) )
            goto CLOSEAC;
    }
#ifdef  _PET_ITEM
	restoreObjects( getStoredir() );
#endif
#ifdef _ITEM_QUITPARTY
	print( "ȡɢƷʧļ..." );
    
	//ȡ
    f = fopen( getitemquitparty(), "r" );
	if( f != NULL ){
		while( fgets( line, sizeof( line ), f ) ){
			if( line[0] == '#' )continue;
            if( line[0] == '\n' )continue;
		    chomp( line );
			itemquitparty_num++;
		}
		if( fseek( f, 0, SEEK_SET ) == -1 ){
			print( "Ʒ¼Ҵ\n" );
			fclose(f);
			goto CLOSEAC;
		}
		//
		Disappear_Item = allocateMemory( sizeof(struct tagDisappearItem) * itemquitparty_num );
		if( Disappear_Item == NULL ){
			print( "޷ڴ %d\n", sizeof(struct tagDisappearItem) * itemquitparty_num );
			fclose( f );
			goto CLOSEAC;
		}

		i = 0;
		//߱Ŵ Disappear_Item.string
		while( fgets( line, sizeof( line ), f ) ){
			if( line[0] == '#' )continue;
			if( line[0] == '\n' )continue; 
			chomp( line );
			sprintf( Disappear_Item[i].string,"%s",line );
			print("\n߱:%s", Disappear_Item[i].string );
			i++;
		}
		fclose(f);
	}
#endif

    DEBUG_ADJUSTTIME = 0;
    print( "\n" );
    return TRUE;

CLOSEAC:
    close( acfd );
CLOSEBIND:
    close( bindedfd );
    endConnect();
MEMEND:
    memEnd();
RETURNFALSE:
    return FALSE;
}

